﻿@page "/reservation"
@using HotelAppServerSide.Data
@using Microsoft.EntityFrameworkCore
@using HotelData.DatabaseAccess
@inject IDbContextFactory<HotelDataContext> HotelDataContextFactory
@inject HotelDataService DataService
@attribute [StreamRendering]
@rendermode InteractiveServer
@inject ILogger<NewReservation> Logger

<PageTitle>Make a Reservation</PageTitle>

@if (ShowNoRoomsFound)
{
    <MudItem>
        <MudPaper Class="pa-4 ma-4 rounded-lg" Elevation="3" Style="@($"color:{Theme.Palette.Dark}; background:{Theme.Palette.ErrorDarken};")">
            <MudText Style="@($"color:{Theme.Palette.White}")">
                Unfortunately, no available rooms were found between your provided time period.
            </MudText>
        </MudPaper>
    </MudItem>
}

@if (ShowClientDataNotMatch)
{
    <MudItem>
        <MudPaper Class="pa-4 ma-4 rounded-lg" Elevation="3" Style="@($"color:{Theme.Palette.Dark}; background:{Theme.Palette.ErrorDarken};")">
            <MudText Style="@($"color:{Theme.Palette.White}")">
                We detect that your ID has been used before, but your other data doesn't match. If you believe this to be an error, please contact us.
            </MudText>
        </MudPaper>
    </MudItem>
}

@if (ShowAlreadyHasReservation)
{
    <MudItem>
        <MudPaper Class="pa-4 ma-4 rounded-lg" Elevation="3" Style="@($"color:{Theme.Palette.Dark}; background:{Theme.Palette.ErrorDarken};")">
            <MudText Style="@($"color:{Theme.Palette.White}")">
                We detect that you've already made a reservation. Please either cancel it or finish your current reservation.
            </MudText>
        </MudPaper>
    </MudItem>
}

@if (ShowReservationLastSecondOverlap)
{
    <MudItem>
        <MudPaper Class="pa-4 ma-4 rounded-lg" Elevation="3" Style="@($"color:{Theme.Palette.Dark}; background:{Theme.Palette.ErrorDarken};")">
            <MudText Style="@($"color:{Theme.Palette.White}")">
                We're sorry, but someone has made a reservation to this room and it overlaps with your time. Please select another room, if available.
            </MudText>
        </MudPaper>
    </MudItem>
}

@if (ShowReservationSuccess)
{
    <MudItem>
        <MudPaper Class="pa-4 ma-4 rounded-lg" Elevation="3" Style="@($"color:{Theme.Palette.Dark}; background:{Theme.Palette.SuccessDarken};")">
            <MudText Style="@($"color:{Theme.Palette.White}")">
                Your reservation was successful! See you soon!
            </MudText>
        </MudPaper>
    </MudItem>
}

<MudContainer Class="mt-4" MaxWidth="MaxWidth.ExtraLarge">
    <MudGrid Spacing="2">
        <MudItem xs="6">
            <MudPaper Class="pa-4 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")" Elevation="3">
                <MudText Typo="Typo.h6">When do you want to make a reservation?</MudText>

                <MudGrid Spacing="0" Class="align-items-center">
                    <MudItem xs="2">
                        <MudText Typo="Typo.h6">From</MudText>
                    </MudItem>
                        <MudItem xs="10" class="align-right">
                            <MudDatePicker Label="Start Date"
                                           DateFormat="dd.MM.yyyy"
                                           PickerVariant="PickerVariant.Dialog"
                                           DisableToolbar="true"
                                           AutoClose="true"
                                           MinDate="DateTime.Today"
                                           Date="@MakeReservation.StartDate"
                                           DateChanged="@OnStartDateChanged" />
                        </MudItem>
                    
                </MudGrid>

                <MudGrid Spacing="0" Class="align-items-center">
                    <MudItem xs="2">
                        <MudText Typo="Typo.h6">To</MudText>
                    </MudItem>
                    <MudItem xs="10">
                        <MudDatePicker Label="End Date"
                                       DateFormat="dd.MM.yyyy"
                                       PickerVariant="PickerVariant.Dialog"
                                       DisableToolbar="true"
                                       AutoClose="true"
                                       MinDate="MakeReservation.StartDate?.AddDays(1)"
                                       Date="@MakeReservation.EndDate"
                                       DateChanged="@OnEndDateChanged" />
                    </MudItem>
                </MudGrid>

                @if (AvailableRooms.Count == 0)
                {
                    <MudItem Class="mt-2">
                        <MudButton Variant="Variant.Filled" Color="Color.Primary" OnClick="CheckAvailability" Disabled="@CheckButtonDisabled">Check Availability</MudButton>
                    </MudItem>
                }

            </MudPaper>

            @if (@ShowCreate)
            {
                <MudPaper Class="pa-4 mt-2 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")" Elevation="3">
                    <MudItem>
                        <MudText Typo="Typo.h6">@($"Room selected - {MakeReservation.RoomName}")</MudText>
                    </MudItem>

                    <MudItem>
                        <MudTextField T="string" Label="First Name" @bind-Value="@MakeReservation.FirstName" ErrorText="Please enter your first name" Error="@ShowErrors[0]" />
                    </MudItem>

                    <MudItem>
                        <MudTextField T="string" Label="Last Name" @bind-Value="@MakeReservation.LastName" ErrorText="Please enter your last name" Error="@ShowErrors[1]" />
                    </MudItem>

                    <MudItem>
                        <MudTextField T="string" Mask="@(new PatternMask("00000000000"))" Label="Person ID" @bind-Value="@MakeReservation.PersonID" ErrorText="The written Person ID is not valid" Error="@ShowErrors[2]" />
                    </MudItem>

                    <MudItem>
                        <MudTextField T="string" Label="Email" @bind-Value="@MakeReservation.Email" ErrorText="The provided value is not a valid email" Error="@ShowErrors[3]" />
                    </MudItem>

                    <MudItem Class="mt-2">
                        <MudButton Variant="Variant.Filled" Color="Color.Primary" OnClick="CreateNewClientReservation" Disabled="@CreateButtonDisabled">Submit</MudButton>
                    </MudItem>
                </MudPaper>
            }

        </MudItem>

        <MudItem xs="6">

            @if (AvailableRooms.Count > 0)
            {
                <MudPaper Class="pa-4 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")" Elevation="3">
                    <MudTable T="HotelRoom" Items="AvailableRooms" Hover="true" Breakpoint="Breakpoint.Sm"
                              Style="@($"background:{Colors.Purple.Lighten5};")"
                              RowClass="cursor-pointer" OnRowClick="OnAvailableRowClicked">
                        <HeaderContent>
                            <MudTh><MudTableSortLabel SortBy="new Func<HotelRoom, object>(x=>x.RoomNumber)">Room</MudTableSortLabel></MudTh>
                            <MudTh><MudTableSortLabel SortBy="new Func<HotelRoom, object>(x=>x.BedCount)">Bed Count</MudTableSortLabel></MudTh>
                            <MudTh><MudTableSortLabel SortBy="new Func<HotelRoom, object>(x=>x.DayCost)">Daily Price</MudTableSortLabel></MudTh>
                            <MudTh><MudTableSortLabel SortBy="new Func<HotelRoom, object>(x=>x.DayCost)">Total Price<br />(Click to sort)</MudTableSortLabel></MudTh>
                        </HeaderContent>
                        <RowTemplate>
                            <MudTd>@context.RoomNumber</MudTd>
                            <MudTd>@context.BedCount</MudTd>
                            <MudTd>@(context.DayCost) €</MudTd>
                            <MudTd>@(HelperFunctions.GetReservationCost(context.DayCost, MakeReservation.StartDate, MakeReservation.EndDate)) €</MudTd>
                        </RowTemplate>
                    </MudTable>
                </MudPaper>
            }

            
        </MudItem>
    </MudGrid>
</MudContainer>